<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>2. 作成したプログラム &mdash; 計算機実習 1.0 documentation</title>
    
    <link rel="stylesheet" href="../_static/default.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '1.0',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <link rel="top" title="計算機実習 1.0 documentation" href="../index.html" /> 
  </head>
  <body>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li><a href="../index.html">計算機実習 1.0 documentation</a> &raquo;</li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body">
            
  <div class="section" id="id1">
<h1>2. 作成したプログラム<a class="headerlink" href="#id1" title="Permalink to this headline">¶</a></h1>
<p>Pythonを用いて作成したプログラムを以下に示す。</p>
<ul class="simple">
<li>6-6_feigenbaum-a.py</li>
</ul>
<p>このプログラムでは表の数値 <img class="math" src="../_images/math/f1147d23bfa452fbd0beb37d227723a644f22e06.png" alt="b_{k}"/> を使って <img class="math" src="../_images/math/0169cf914e137589405e489b4bbd3d3ae243a1a3.png" alt="\delta_{k}=(b_{k}-b_{k-1})/(b_{k+1}-b_{k})"/> を <img class="math" src="../_images/math/e9203da50e1059455123460d4e716c9c7f440cc3.png" alt="k"/> に対してプロットし、単純な相加平均によって <img class="math" src="../_images/math/b35a9439ad8c8657b1b1d792ad5c2d77a52c0aef.png" alt="\delta"/> を求めることができる。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
36
37
38
39
40
41
42
43
44
45
46
47
48
49</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! usr/bin/env python </span>
<span class="c"># coding:utf-8</span>

<span class="sd">&quot;&quot;&quot; 計算機実習</span>
<span class="sd">問題6.6 ファイゲンバウム定数の評価</span>
<span class="sd">-a 相加平均でファイゲンバウム定数を求める</span>
<span class="sd">作成者：藤本將太郎</span>
<span class="sd">&quot;&quot;&quot;</span>

<span class="kn">import</span> <span class="nn">matplotlib.pylab</span> <span class="kn">as</span> <span class="nn">plt</span>
<span class="kn">from</span> <span class="nn">Tkinter</span> <span class="kn">import</span> <span class="o">*</span>
<span class="kn">import</span> <span class="nn">numpy</span>

<span class="n">b</span><span class="o">=</span><span class="p">[</span><span class="mf">0.750000</span><span class="p">,</span> <span class="mf">0.862372</span><span class="p">,</span> <span class="mf">0.886023</span><span class="p">,</span> <span class="mf">0.891102</span><span class="p">,</span> <span class="mf">0.892190</span><span class="p">,</span> <span class="mf">0.892423</span><span class="p">,</span> <span class="mf">0.892473</span><span class="p">,</span> <span class="mf">0.892484</span><span class="p">]</span>
<span class="c">#        b1          b2          b3          b4          b5          b6          b7          b8</span>

<span class="k">def</span> <span class="nf">delta</span><span class="p">(</span><span class="n">k</span><span class="p">):</span>
    <span class="k">return</span> <span class="p">(</span><span class="n">b</span><span class="p">[</span><span class="n">k</span><span class="o">-</span><span class="mi">1</span><span class="p">]</span> <span class="o">-</span> <span class="n">b</span><span class="p">[</span><span class="n">k</span><span class="o">-</span><span class="mi">2</span><span class="p">])</span><span class="o">/</span><span class="p">(</span><span class="n">b</span><span class="p">[</span><span class="n">k</span><span class="p">]</span><span class="o">-</span><span class="n">b</span><span class="p">[</span><span class="n">k</span><span class="o">-</span><span class="mi">1</span><span class="p">])</span>

<span class="n">plt</span><span class="o">.</span><span class="n">gca</span><span class="p">()</span><span class="o">.</span><span class="n">set_xlim</span><span class="p">(</span><span class="mf">1.5</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">b</span><span class="p">)</span><span class="o">-</span><span class="mf">0.5</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">xlabel</span><span class="p">(</span><span class="s">r&#39;$k$&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">ylabel</span><span class="p">(</span><span class="s">r&#39;$\delta_{k}$&#39;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">title</span><span class="p">(</span><span class="s">&#39;Feigenbaum constant&#39;</span><span class="p">)</span>
<span class="n">sum_delta_k</span><span class="o">=</span><span class="mi">0</span>

<span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">2</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">b</span><span class="p">)):</span>
    <span class="n">plt</span><span class="o">.</span><span class="n">scatter</span><span class="p">(</span><span class="n">k</span><span class="p">,</span> <span class="n">delta</span><span class="p">(</span><span class="n">k</span><span class="p">),</span> <span class="n">color</span><span class="o">=</span><span class="s">&#39;r&#39;</span><span class="p">,</span> <span class="n">s</span><span class="o">=</span><span class="mi">8</span><span class="p">,</span> <span class="n">marker</span><span class="o">=</span><span class="s">&#39;o&#39;</span><span class="p">)</span>
<span class="c">#    sum_delta_k=sum_delta_k+delta(k)</span>
<span class="c">#ave_delta_k=sum_delta_k/6</span>
<span class="c">#</span>
<span class="c"># -- edited --</span>

<span class="k">for</span> <span class="n">k</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="mi">3</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">b</span><span class="p">)</span><span class="o">-</span><span class="mi">1</span><span class="p">):</span>
    <span class="n">sum_delta_k</span> <span class="o">=</span> <span class="n">sum_delta_k</span><span class="o">+</span><span class="n">delta</span><span class="p">(</span><span class="n">k</span><span class="p">)</span>
<span class="n">ave_delta_k</span> <span class="o">=</span> <span class="n">sum_delta_k</span><span class="o">/</span><span class="mi">4</span>

<span class="c">#plt.plot([2, len(b)-1], [ave_delta_k]*2, </span>
<span class="c">#                        label=r&#39;$\mathrm{average}\ \mathrm{of}\ \delta_{k}\ :\ \delta \ =\ $&#39; </span>
<span class="c">#                        + str(ave_delta_k)</span>
<span class="c">#                        )</span>
<span class="c"># -- edited --</span>

<span class="n">plt</span><span class="o">.</span><span class="n">plot</span><span class="p">([</span><span class="mi">3</span><span class="p">,</span> <span class="nb">len</span><span class="p">(</span><span class="n">b</span><span class="p">)</span><span class="o">-</span><span class="mi">2</span><span class="p">],</span> <span class="p">[</span><span class="n">ave_delta_k</span><span class="p">]</span><span class="o">*</span><span class="mi">2</span><span class="p">,</span> 
        <span class="n">label</span><span class="o">=</span><span class="s">r&#39;$\mathrm{average}\ \mathrm{of}\ \delta_{k}\ :\ \delta \ =\ $&#39;</span> 
             <span class="o">+</span> <span class="nb">str</span><span class="p">(</span><span class="n">ave_delta_k</span><span class="p">)</span>
        <span class="p">)</span>

<span class="n">plt</span><span class="o">.</span><span class="n">legend</span><span class="p">(</span><span class="n">loc</span><span class="o">=</span><span class="s">&quot;best&quot;</span><span class="p">)</span>
<span class="n">plt</span><span class="o">.</span><span class="n">show</span><span class="p">()</span>
</pre></div>
</td></tr></table></div>
<ul class="simple">
<li>6-6_feigenbaum-fit.py</li>
</ul>
<p>下のプログラムを実行すると、プログラム内で指定されたパラメータ初期値を用いて、最小2乗法により式 <a href="#equation-e1">(?)</a> におけるパラメータ <img class="math" src="../_images/math/65868d23a5bfe5b3b2d819386b19c14fa36af134.png" alt="c"/> 、 <img class="math" src="../_images/math/16fb202a63a75cb12495aa1f061d134bfd9aa12f.png" alt="r_{\infty}"/> を求めることができる。モジュールとしてscipyモジュールのoptimizeを用いている。</p>
<div class="highlight-python"><table class="highlighttable"><tr><td class="linenos"><div class="linenodiv"><pre> 1
 2
 3
 4
 5
 6
 7
 8
 9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27</pre></div></td><td class="code"><div class="highlight"><pre><span class="c">#! usr/bin/env python </span>
<span class="c"># coding:utf-8</span>
<span class="sd">&quot;&quot;&quot; 計算機実習</span>
<span class="sd">問題6.6 ファイゲンバウム定数の評価</span>
<span class="sd">-a 最小2乗法で r_infinity を求める。</span>
<span class="sd">作成者：藤本將太郎</span>
<span class="sd">&quot;&quot;&quot;</span>
<span class="kn">import</span> <span class="nn">scipy.optimize</span> <span class="kn">as</span> <span class="nn">optimize</span>
<span class="kn">from</span> <span class="nn">numpy</span> <span class="kn">import</span> <span class="o">*</span>

<span class="n">delta</span><span class="o">=</span><span class="mf">4.669201609102991</span>
<span class="c">#b=[0.750000, 0.862372, 0.886023, 0.891102, 0.892190, 0.892423, 0.892473, 0.892484]</span>
<span class="c">#k=range(1, len(b)+1)</span>
<span class="n">b</span><span class="o">=</span><span class="p">[</span><span class="mf">0.886023</span><span class="p">,</span> <span class="mf">0.891102</span><span class="p">,</span> <span class="mf">0.892190</span><span class="p">,</span> <span class="mf">0.892423</span><span class="p">]</span>
<span class="n">k</span><span class="o">=</span><span class="nb">range</span><span class="p">(</span><span class="mi">3</span><span class="p">,</span> <span class="mi">7</span><span class="p">)</span>
<span class="n">parameter0</span><span class="o">=</span><span class="p">[</span><span class="mf">1.0</span><span class="p">,</span> <span class="mf">1.0</span><span class="p">]</span> <span class="c"># c, r_m　初期値</span>

<span class="k">def</span> <span class="nf">fit_func</span><span class="p">(</span><span class="n">parameter0</span><span class="p">,</span><span class="n">k</span><span class="p">,</span><span class="n">b</span><span class="p">):</span>
    <span class="n">c</span> <span class="o">=</span> <span class="n">parameter0</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
    <span class="n">r_infinity</span> <span class="o">=</span> <span class="n">parameter0</span><span class="p">[</span><span class="mi">1</span><span class="p">]</span>
    <span class="n">residual</span><span class="o">=</span><span class="n">b</span><span class="o">-</span><span class="p">(</span><span class="n">r_infinity</span><span class="o">-</span><span class="n">c</span><span class="o">*</span><span class="n">delta</span><span class="o">**</span><span class="p">(</span><span class="o">-</span><span class="n">k</span><span class="p">))</span>
    <span class="k">return</span> <span class="n">residual</span>

<span class="n">result</span><span class="o">=</span><span class="n">optimize</span><span class="o">.</span><span class="n">leastsq</span><span class="p">(</span><span class="n">fit_func</span><span class="p">,</span> <span class="n">parameter0</span><span class="p">,</span> <span class="n">args</span><span class="o">=</span><span class="p">(</span><span class="n">array</span><span class="p">(</span><span class="n">k</span><span class="p">),</span><span class="n">array</span><span class="p">(</span><span class="n">b</span><span class="p">)))</span>

<span class="k">print</span> <span class="s">&#39;c=&#39;</span><span class="p">,</span> <span class="n">result</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span>
<span class="k">print</span> <span class="s">&#39;r_infinity=&#39;</span><span class="p">,</span> <span class="n">result</span><span class="p">[</span><span class="mi">0</span><span class="p">][</span><span class="mi">1</span><span class="p">]</span>
</pre></div>
</td></tr></table></div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar">
        <div class="sphinxsidebarwrapper">
  <h3>This Page</h3>
  <ul class="this-page-menu">
    <li><a href="../_sources/6-6_feigenbaum/program.txt"
           rel="nofollow">Show Source</a></li>
  </ul>
<div id="searchbox" style="display: none">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li><a href="../index.html">計算機実習 1.0 documentation</a> &raquo;</li> 
      </ul>
    </div>
    <div class="footer">
        &copy; Copyright 2014, Shotaro Fujimoto.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.2.2.
    </div>
  </body>
</html>